/*
 * CG Madness - a Marble Madness clone
 * Copyright (C) 2007  Sven Reinck <sreinck@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef MessageDispatcher_hpp
#define MessageDispatcher_hpp

#include "Package.hpp"

#include "utils/String.hpp"

#include "libgrapple/grapple_types.h"

class MessageDispatcher
{
public:
  MessageDispatcher();
  virtual ~MessageDispatcher();

  virtual void log(const String& log) = 0;

  virtual void newUser(grapple_user id, bool me, const char* name);
  virtual void userName(grapple_user id, const char* name);
  virtual void userDisconnected(grapple_user id);
  virtual void serverDisconnected();
  virtual void connectionRefused(grapple_connection_refused reason);

  virtual void package(const Package& package) = 0;

private:

};

#endif
